<?php
    require_once(dirname(dirname(dirname(__FILE__))).'/config.php');
    require_once(dirname(__FILE__).'/lib.php');
    require_once($CFG->libdir.'/filelib.php');
    require_once('locallib.php');


    global $DB;


    $id = optional_param('id', 0, PARAM_INT); // course_module ID, or
    $g  = optional_param('g', 0, PARAM_INT);  // gradeimporter instance ID, should be named as the first character of the module
    $action = optional_param('action', 0, PARAM_INT);
    $cmid = optional_param('cmid', 0, PARAM_INT);
    $id       = optional_param('id', 0, PARAM_INT);
    $fileid     = optional_param('fileid', 0, PARAM_INT);
    $filename   = optional_param('filename', 'a', PARAM_TEXT);

    

    if ($id) {
        if (! $cm = get_coursemodule_from_id('gradeimporter', $id)) {
            error('Course Module ID was incorrect');
        }

        if (! $course = $DB->get_record('course', array('id'=> $cm->course))) {
            error('Course is misconfigured');
        }

        if (! $gradeimporter = $DB->get_record('gradeimporter', array('id'=> $cm->instance) ) ) {
            error('Course module is incorrect');
        }

    } else if ($g) {
        if (! $gradeimporter = $DB->get_record('gradeimporter', array('id'=> $g)) ){
            error('Course module is incorrect');
        }
        if (! $course = $DB->get_record('course', array('id'=> $gradeimporter->course)) ) {
            error('Course is misconfigured');
        }
        if (! $cm = get_coursemodule_from_instance('gradeimporter', $gradeimporter->id, $course->id)) {
            error('Course Module ID was incorrect');
        }

    } else {
        error('You must specify a course_module ID or an instance ID');
    }

    require_login($course, true, $cm);

    $context = context_module::instance($cm->id);



    if ($action==1 && has_capability('mod/gradeimporter:view', $context)){
      //download feedback file
      $fs = get_file_storage();
      $file = $fs->get_file($context->id, 'mod_gradeimporter', 'gradeimporter_feedback', $fileid, '/', $filename);
      if ($file){
        send_stored_file($file, 86400, 0, true);
      }
    } else if ($action == 2 && has_capability('mod/gradeimporter:edit', $context)){
      //download students csv with their id
      exportCSV($context);
    }


    /// Print the page header
    $PAGE->set_cm($cm);
    $PAGE->set_url('/mod/gradeimporter/view.php', array('id' => $cm->id));
    $PAGE->set_title(format_string($gradeimporter->name));
    $PAGE->set_heading(format_string($course->fullname));
    $PAGE->set_context($context);

$output = $PAGE->get_renderer('mod_folder');
echo $output->header();

$heading = get_string('displayingview', 'gradeimporter', $gradeimporter->name);

echo $output->heading($heading);


//button to add new submission
if (has_capability('mod/gradeimporter:edit', $context)) {
  $url = new moodle_url('/mod/gradeimporter/submission.php');
  $newbutton = '<form action="'. $url . '">'.
          '<input type="hidden" name="id" value="'. $gradeimporter->id .'" />'.
          '<input type="hidden" name="cmid" value="'.$cm->id.'" />'.
          '<input type="hidden" name="page" value="0" />'.
          '<input type="submit" Value="'.get_string('newsubmission', 'gradeimporter').'" />'.
          '</form>';
  echo $newbutton;

  $url = new moodle_url("/mod/gradeimporter/view.php", array('id'=>$id, 'cmid'=>$cm->id, 'action'=>2));
  $newbutton = '<form action="'. $url . '">'.
        '<input type="hidden" name="id" value="'. $id .'" />'.
        '<input type="hidden" name="cmid" value="'.$cm->id.'" />'.
        '<input type="hidden" name="action" value="2" />'.
        '<input type="submit" Value="'.get_string('downloadconfigcsv', 'gradeimporter').'" />'.
        '</form>';
  echo $newbutton;
}

//tabela com as notas vem aqui

require_once($CFG->libdir . '/tablelib.php');
require_once(dirname(__FILE__).'/locallib.php');
use \gradeimporter\feedback;

$data = feedback::get_comments($cm->id, $id);

if (has_capability('mod/gradeimporter:edit', $context)){
  //loads teacher view
  $table = new html_table();
  $table->attributes['class'] = 'generaltable mod_index';
  $table->head  = array ("Aluno", "Tipo", "Nome", "Nota", "Arquivos");
  $table->align = array ('center', 'center', 'center', 'center', 'center');

  if (count($data)) {
    $currentAluno = "";
    foreach ($data as $aluno => $datas) {
      if ($currentAluno != "" && $currentAluno != $aluno) {
        $row = new html_table_row();
        $cell = new html_table_cell();
        $cell->colspan = 6;
        $row->cells[] = $cell;
        $table->data[] = $row;
      }
      $t = count($datas);
      foreach ($datas as $tipo => $cells) {$t += count($cells);};
      $currentAluno = $aluno;
      $row = new html_table_row();
      $cell = new html_table_cell($aluno);
      $cell->rowspan = $t+1;
      $row->cells[] = $cell;
      $table->data[] = $row;

      foreach ($datas as $tipo => $cells) {
        $row = new html_table_row();
        $cell = new html_table_cell($tipo);
        $cell->rowspan = count($cells)+1;
        $row->cells[] = $cell;
        $table->data[] = $row;

        foreach ($cells as $cell) {
          $row = new html_table_row();
          foreach ($cell as $value) {
            $row->cells[] = new html_table_cell($value);
          }
          $table->data[] = $row;
        }
      }
    }
  }
} else {
  //loads student view
  $table = new html_table();
  $table->attributes['class'] = 'generaltable mod_index';
  $table->head  = array ("Tipo", "Nome", "Nota", "Comentários", "Arquivos");
  $table->align = array ('center', 'center', 'center', 'center', 'center');

  if (count($data)) {
    $current = "";
    foreach ($data as $tipo => $cells) {
      if ($current != "" && $current != $tipo) {
        $row = new html_table_row();
        $cell = new html_table_cell();
        $cell->colspan = 5;
        $row->cells[] = $cell;
        $table->data[] = $row;
      }
      $current = $tipo;

      $row = new html_table_row();
      $cell = new html_table_cell($tipo);
      $cell->rowspan = count($cells)+1;
      $row->cells[] = $cell;
      $table->data[] = $row;
      foreach ($cells as $cell) {
        $row = new html_table_row();
        foreach ($cell as $value) {
          $cell = new html_table_cell($value);
          $row->cells[] = $cell;
        }
        $table->data[] = $row;
      }
    }
  }
}


echo html_writer::table($table);
/// Finish the page
echo $output->footer();